#{extends 'borderNG.html' /}


#{set 'titleHead'}
&{'auction.info_tender'} ${lelang.namaPaket}
#{/set}

<ul class="breadcrumb">
    <li><a href="@{BerandaCtr.index()}">&{'auction.home'}</a></li>
    <li class="active">&{'auction.info_tender'}</li>
</ul>

#{tabmenuLelang tahapStarted/}
<div class="content">
    <table class="table table-sm">
        <tr>
            <td><b>${lelang.lls_id} #{sesiInfo lelang.lls_sesi /}</b>
            <th width="25%" class="bg-warning">&{'auction.kode'}</th>
            <td><b>${lelang.lls_id} #{if !production} <span class="label label-info">#{if lelang.lls_sesi == 0} sesi default#{/if} #{else}
                sesi ${lelang.lls_sesi}#{/else}</span> #{/if}</b>
            </td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.nama'}</th>
            <td>${lelang.namaPaket} #{statusTender lelang/}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.metode'}</th>
            <td>${lelang.pemilihan.label}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.waktu'}</th>
            <td id="waktu">${auction?.ra_waktu_mulai?.formatDateTime()} s.d. ${auction?.ra_waktu_selesai?.formatDateTime()}</td>
        <tr>
            <th class="bg-warning">&{'auction.sisa_waktu'}</th>
            <td id="waktu">${auction.sisaWaktu()}</td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.nilai_min'}</th>
            <td>${auction?.ra_min_penawaran?.rupiah()}</td>
        </tr>
        <tr>
            <td colspan="2" id="hps-content">
                <div id="alert"></div>
                <div id="tbl-rincian" style="margin:20px; margin-bottom: 50px;"></div>
                <div class="float-right">
                    <table id="rekap" class="table table-sm" style="width:300px;margin-right:170px;">
                        <tr>
                            <th style="text-align:right">TOTAL NILAI</th>
                            <th id="total_hps" style="text-align:right"></th>
                        </tr>
                    </table>
                </div>
            #{if editable}
                #{authenticityToken /}
                <button type="button" name="simpan" id="simpan" class="btn btn-success"><i class="fa fa-save"></i> &{'auction.kirim'}
                    &{'auction.penawaran'}
                </button>
            #{/if}
            </td>
        </tr>
        <tr>
            <th class="bg-warning">&{'auction.penawaran'}</th>
            <td>
                <table class="table table-sm table-bordered" id="penawaranList">
                    <thead>
                    <tr>
                        <th>&{'auction.harga_penawaran'}</th>
                        <th>&{'auction.waktu_pengiriman'}</th>
                        <th>&{'auction.keterangan'}</th>
                    </tr>
                    </thead>
                    <tbody>
                    #{list items:penawaranlist, as:'item'}
                    <tr id="${item.rad_id}">
                        <td>${item.rad_nev_harga?.rupiah()}</td>
                        <td>${item.auditupdate?.formatDateTime()}</td>
                        <td>${penawaranTermurah && penawaranTermurah == item.rad_id ? 'Penawaran Anda Terendah':''}</td>
                    </tr>
                    #{/list}
                    </tbody>
                </table>
            </td>
        </tr>
    </table>

</div>

#{set 'css_custom' }
<link href="#{assets '/handsontable/handsontable.full.min.css'/}" rel="stylesheet" type="text/css">
#{/set}

#{set 'custom_script'}
<script type="text/javascript" src="#{assets '/handsontable/handsontable.full.min.js'/}"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/PapaParse/5.1.0/papaparse.min.js"></script>
<script type="text/javascript">
        var WS = window['MozWebSocket'] ? MozWebSocket : WebSocket;
        #{if editable}
        window.onload = setTimeout("location.reload(true);", 25*60*1000);
        // Create a socket
        var interval;
        var socket = new WS('@@{lelang.AuctionCtr.AuctionWebsocketCtr.join(lelang.lls_id)}')
        socket.onopen = function (event) {
            interval = setInterval(function(){
                // console.log(msg);
                socket.send("update time");
            }, 1000)
        }
        socket.onmessage = function (event) {
            var obj = $.parseJSON(event.data)
            if(obj.waktu) {
                $('#waktu').html(obj.waktu)
            }
            if(obj.data) {
                // console.log('data : '+JSON.stringify(obj.data))
                var row = '<tr id="'+obj.data.id+'"><td>' + obj.data.penawaran + '</td><td>' + obj.data.waktu_pengiriman + '</td><td>' + obj.data.keterangan + '</td></tr>';
                var firstRow = $("#penawaranList tbody tr:first")
                if(obj.data.keterangan.length > 0) { // hapus keterangan
                    firstRow.find('td:last').html("");
                }
                if(firstRow.attr("id") == obj.data.id ) {
                    firstRow.remove()
                }
                $('#penawaranList tbody').prepend(row)
            }
            if(obj.message){
                if (obj.message === 'ok')
                    $('#alert').html('<div class="alert alert-success" data-auto-dismiss="2000">Data berhasil tersimpan</div>');
                else if (obj.message.length > 0)
                    $('#alert').html('<div class="alert alert-danger" data-auto-dismiss="2000">' + obj.message + '</div>');
                autoCloseAlert();
            }
        }
        socket.onclose = function (event) {
            console.log("socket closed", event)
            clearInterval(interval);
        }
        socket.onerror = function (event) {
            console.log("Error ", event)
            $('#alert').html('<div class="alert alert-danger" data-auto-dismiss="2000">Data gagal tersimpan karena ada kendala jaringan/server</div>');
            autoCloseAlert();
        }
        #{/if}
        var data = ${data?.raw()};
        var interval = 2 * 60 * 1000; // 2 menit
        var total = 0;
        var fixed = true;

        function replaceChar(str) {
            var strs = "";
            if (str != undefined)
                strs += str;

            return strs.replace(/[^a-zA-Z0-9.,!@#$%&@*()-+=/\-\s ]/g, "");
        }

        var language = {
            delimiters: {
                thousands: '.',
                decimal: ','
            },
            abbreviations: {
                thousand: 'rb',
                million: 'jt',
                billion: 'M',
                trillion: 'B'
            },
            ordinal: function (number) {
                var b = number % 10;
                return (~~(number % 100 / 10) === 1) ? 'th' : (b === 1) ? 'st' : (b === 2) ? 'nd' : (b === 3) ? 'rd' : 'th';
            },
            currency: {
                symbol: 'Rp.'
            }
        };

        // Node
        if (typeof module !== 'undefined' && module.exports) {
            module.exports = language;
        }

        // Browser
        if (typeof window !== 'undefined' && this.numeral && this.numeral.language) {
            this.numeral.language('id', language);
        }

        $("#tbl-rincian").handsontable({
            rowHeaders: true,
            dataSchema: {
                item: "",
                unit: "",
                vol: 1,
                // unit2: "",
                // vol2: 1,
                harga: 0,
                pajak: 10,
                total_harga: 0,
                keterangan: ""
            },
            data: data,
            #{if editable}
                contextMenu: {
                    callback: function (key, row, col, options) {
                        if (key === 'make_read_only') {
                            console.log("row : " + row);
                            console.log("col : " + col);
                        }
                    },
                    items: {
                        "row_above": {name: "&{'paket.tambah_baris_diatas'}"},
                        "row_below": {name: "&{'paket.tambah_baris_dibawah'}"},
                        "remove_row": {name: "&{'paket.hapus_baris'}"},
                        "undo": {name: "&{'paket.undo'}"},
                        "redo": {name: "&{'paket.redo'}"}
                    }
                },
            #{/if}
            language: 'id',
            columns: [{data: 'item', width: 200, title: '&{'paket.jenis_barang_jasa'}', readOnly: true},
                {data: 'unit', width: 100, title: '&{'paket.satuan'}', readOnly: true},
                {
                    data: 'vol',
                    type: 'numeric',
                    format: '0,0.00',
                    width: 50,
                    title: 'Vol',
                    allowInvalid: false,
                    readOnly: true
                },
                // {data: 'unit2', width: 100, title: 'Satuan 2', allowInvalid: false, readOnly: true},
                // {
                //     data: 'vol2',
                //     type: 'numeric',
                //     format: '0,0.00',
                //     width: 50,
                //     title: 'Vol 2',
                //     allowInvalid: false,
                //     readOnly: true
                // },
                {data: 'harga', type: 'numeric', format: '0,0.00', width: 100, title: '&{'paket.harga'}', allowInvalid: false},
                {
                    data: 'pajak',
                    type: 'numeric',
                    format: '0,0.00',
                    width: 60,
                    title: '&{'paket.pajak'} (%)',
                    dataSchema: 10,
                    allowInvalid: false
                },
                {data: 'total_harga', type: 'numeric', format: '0,0.00', width: 100, title: '&{'paket.total'}', allowInvalid: false},
                {data: 'keterangan', width: 100, title: '&{'paket.keterangan'}'}],
            cells: function (row, col, prop) {
                var cellProperties = {};
                #{if editable}
                    if (col == 5) {
                        cellProperties.readOnly = true;
                    }
                    if (data[row] && (col == 2 || col == 3 || col == 4)) {
                        var total = 0;
                        var strs = "";
                        if (data[row].vol <= 0)
                            data[row].vol = 1.0;
                        if (data[row].harga > 0)
                            total = data[row].harga;
                        if (data[row].vol > 0) {
                            data[row].vol = rounded2Decimal(parseFloat(data[row].vol));
                            total = total * data[row].vol;
                        }
                        if (data[row].pajak > 0)
                            total = total + ((total * data[row].pajak) / 100);
                        else
                            data[row].pajak = 0;
                        if (total >= 0) {
                            data[row].total_harga = rounded2Decimal(total);
                        }
                    }
                    if (data[row] && (col == 1 || col == 2 || col == 6)) {
                        data[row].item = replaceChar(data[row].item);
                        data[row].unit = replaceChar(data[row].unit);
                        data[row].keterangan = replaceChar(data[row].keterangan);
                    }
                #{/if}
                #{else}
                    cellProperties.readOnly = true;
                #{/else}
                return cellProperties;
            },
            afterChange: function (change, source) {
                summary();
            },
            afterRemoveRow: function () {
                summary();
            }
        });

        function summary() {
            var data = $("#tbl-rincian").data('handsontable').getData();
            var total_hps = 0;
            var total = 0;
            for (i = 0; i < data.length; i++) {
                if (data[i].total_harga)
                    total += parseFloat(data[i].total_harga);
            }
            if (total > 0) {
                total_hps = parseFloat(total);
            }
            $("#rekap").find("#total_hps").text(toRupiah(rounded2Decimal(total_hps)));
        }
            #{if editable}
            $(document).on("click", "#simpan", function () {
                var postdata = $("#tbl-rincian").data('handsontable').getData();
                //var token = $("input[name='authenticityToken']").val();
                socket.send(JSON.stringify({"data": postdata}));
            });
            #{/if}

</script>
#{/set}